# pylint:
"""
Django settings for app_starter project.

Generated by 'django-admin startproject' using Django 4.1.1.

For more information on this file, see
https://docs.djangoproject.com/en/4.1/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/4.1/ref/settings/
"""

from pathlib import Path
import os
import environ

# Build paths inside the project like this: BASE_DIR / 'subdir'.
BASE_DIR = Path(__file__).resolve().parent.parent

# Enable the line below if need to specify the path of .env file
environ.Env.read_env()
# environ.Env.read_env(os.path.join(BASE_DIR, 'app_starter/.env.dev'))


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/4.1/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = os.environ.get('SECRET_KEY', 'supersecretkey')

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = os.environ.get('DEBUG', 'True') is not False

# SECURITY WARNING: This attribute allows the hosts listed to host the django project.
# In production, only allow hosts that you want to host your project.
# In development, default already includes "locahost" and "127.0.0.1"
ALLOWED_HOSTS = ['*']
if hosts_str := os.environ.get('ALLOWED_HOSTS'):
    ALLOWED_HOSTS = [
        host.strip()
        for host in hosts_str.split(',')
        if host.strip()
    ]

CSRF_TRUSTED_ORIGINS = []
if origins_str := os.environ.get('CSRF_TRUSTED_ORIGINS'):
    CSRF_TRUSTED_ORIGINS = [
        origin.strip()
        for origin in origins_str.split(',')
        if origin.strip()
    ]

# Configuration for development ONLY
CONFIG = {}
# Set up this configs based on your need
CONFIG['PROJECT_TITLE'] = "Django App Starter"
[CONFIG['PROJECT_VERSION'], CONFIG['VERSION_DESCRIPTION']] =\
['v0.1.5', 'Remove Windows stuffs, configure local testings and fix update changelog script']
CONFIG['PROJECT_HOMEPAGE'] = 'https://gitlab.com/uvic-arcsoft/strap/app-starter-django.git'
# Disable line-too-long C0301 as this string cannot be separated
# into multiple lines because it is rendered as html in the base template
# pylint: disable-next=C0301
CONFIG['ABOUT_CONTENT'] = "<p>This template is built for developers to start up a Django project. Go to <strong>settings.py</strong>, make changes to <code>CONFIG['ABOUT_CONTENT']</code> to change this text</p>"

if DEBUG:
    CONFIG['AUTHX_USER_OVERRIDE'] = os.environ.get('AUTHX_USER_OVERRIDE', None)
    CONFIG['AUTHX_HTTP_HEADER_USER'] = 'X-Forwarded-User'
    CONFIG['AUTHX_HTTP_HEADER_ID_TOKEN'] = 'X-Forwarded-Id-Token'

    # Users will be created for this app from usernames specified here
    # Specify the usernames, and run 'make create_users' or 'python3 manage.py createusers'
    # The default password for all normal users is 'testinguser', for all admin users is 'testingadmin'.
    # Run 'python manage.py changepassword [<username>] to change password for users'.
    CONFIG['AUTHZ_USERS'] = ['user@example.org', 'user1@example.org']
    CONFIG['AUTHZ_ADMINS'] = ['admin@example.org', 'admin1@example.org']

# Default email for all superusers
DJANGO_SUPERUSER_EMAIL = 'admin@example.org'

# Default password for all superusers
DJANGO_SUPERUSER_PASSWORD = 'testingadmin'

# List all the names of editable content texts that are accessible to all pages in the app
GLOBAL_EDITABLE_CONTENTS_NAMES = ['about_content']

# Set to True by django_editablecontent app's test cases
EDITABLECONTENT_TESTING = False

# Application definition
INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
    'normal_users',
    'admin_users',
    'django_editablecontent',
    'django_fileupload'
]

MIDDLEWARE = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
    'middleware.authenticate_middleware.StarterAuthenticateMiddleware'
]

ROOT_URLCONF = 'app_starter.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [os.path.join(BASE_DIR, 'templates')],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'app_starter.custom_contexts.project_setup'
            ],
        },
    },
]

WSGI_APPLICATION = 'app_starter.wsgi.application'


# Database
# https://docs.djangoproject.com/en/4.1/ref/settings/#databases

DATABASES = {
    'default': {
        'ENGINE': 'django.db.backends.sqlite3',
        'NAME': BASE_DIR / 'db.sqlite3',
    }
}


# Password validation
# https://docs.djangoproject.com/en/4.1/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/4.1/topics/i18n/

LANGUAGE_CODE = 'en-us'

TIME_ZONE = 'PST8PDT'

USE_I18N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/4.1/howto/static-files/
# Project looks for static file under "static" folder from the root directory
STATIC_URL = 'static/'
STATIC_ROOT = os.path.join(BASE_DIR.parent, 'staticfiles')
STATICFILES_DIRS = [
    os.path.join(BASE_DIR, "static/"),
]

# Default primary key field type
# https://docs.djangoproject.com/en/4.1/ref/settings/#default-auto-field

DEFAULT_AUTO_FIELD = 'django.db.models.BigAutoField'

# Media files (pdf, jpeg, png)
ROOT_DIR = BASE_DIR.parent
MEDIA_URL = '/media/'
MEDIA_ROOT = os.path.join(ROOT_DIR, 'media')
